clc
clear all; close all

%% Generell Input
%INPUT betong
Xend=95;
Xstart=20;
step=1;
fck=Xstart:step:Xend;
n=((Xend-Xstart)/step)+1;
axisxmin=20;
axisxmax=Xend;
axisymin=0;
axisymax=300;

cnom=30;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
%INPUT armering
boyle=10;
kam16=16;
fyk=500;
ys=1;
fyd=fyk/ys;
Asl=804;
Es=200000;
%INPUT tverrsnitt
bw=250;
h=300;
d=h-cnom-boyle-(kam16/2);
z=0.9*d;
l=6000;
%INPUT laster
qEd=15;
VEd=qEd*0.5*l;
MEd=qEd*l*l/8;
VEd_kontrollsnitt=(VEd-qEd*d);
MEd_kontrollsnitt=-0.5*qEd*(d^2)+VEd*d;
NEd=0;

%% EC2

% Uten skjrarmering
k2=0.18;
CRdc=k2/yc;
k=min(1+(sqrt(200/d)),2.0);
rhol=min(Asl/(bw*d),0.02);
Ac=h*bw;

for i=1:n
    sigmacp(i)=min(NEd/Ac,0.2*fcd(i));
    
    nu(i)=0.6*(1-fck(i)/250);

    vmin(i)=0.035*(k^(3/2))*sqrt(fck(i));

    if NEd <= 0
        k1_ECus(i) = 0.3;
    else NEd > 0
        k1_ECus(i) = 0.15;
    end
    
    VRdcs(i)=max((CRdc*k*((100*rhol*(min(fck(i),65)))^(1/3))+k1_ECus(i)*sigmacp(i))*bw*d,(vmin(i)+k1_ECus(i)*sigmacp(i))*bw*d);
   
    VRdcc(i)=0.5*bw*d*nu(i)*fcd(i);

    VRdc_ECus(i)=min(max(VRdcs(i),0),VRdcc(i))*10^-3;
    
end

%% Model Code
for i=1:n
   if NEd == 0;
       deltae1(i)=0;
   else if MEd_kontrollsnitt/NEd >= h/2;
         deltae1(i) = h/2;
        elseif MEd_kontrollsnitt/NEd <= -h/2;
         deltae1(i) = -h/2;
        else deltae1(i) = MEd_kontrollsnitt/NEd;
       end
   end
    
    epsilonx_formel(i)=max((1/(2*Asl*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt+(NEd*(0.5+(deltae1(i)/z)))),0);
    
    if (MEd_kontrollsnitt/z) < NEd;
        epsilonx(i) = 2 * min(epsilonx_formel(i),0.003);
    else (MEd_kontrollsnitt/z) >= NEd;
        epsilonx(i) = min(epsilonx_formel(i),0.003);
    end
    
  % Uten skjrarmering
  
    if fck(i) <= 70;
        dg(i) = 16;
    else fck(i) > 70;
        dg(i) = 0;
    end

    kdg(i)=max(32/(16+dg(i)),0.75);
    
    kv1_MCus(i)=((0.4)/(1+1500*epsilonx(i)))*((1300)/(1000+kdg(i)*z));
   
    VRdc_MCus(i)=max((kv1_MCus(i)*(min(sqrt(fck(i)),8)/yc)*z*bw)*10^-3,0);

    % Med skjrarmering
    theta=45; %vinkel trykkfelt, 45 grader TSS
    Asw=2*pi*(boyle/2)^2;
    sw=200;
    netafc(i)=max((30/fck(i))^(1/3),1.0);

    thetamin1(i)=20+10000*epsilonx(i);

    epsilon11(i)=epsilonx(i)+(epsilonx(i)+0.002)*((1/tand(thetamin1(i)))^2);

    kepsi1(i)=min(1/(1.2+55*epsilon11(i)),0.65);

    kc1(i)=kepsi1(i)*netafc(i);

    VRds1(i)=(Asw/sw)*z*fyd*cotd(theta);

    VRdmax_thetamin1(i)=kc1(i)*(fck(i)/yc)*bw*z*sind(thetamin1(i))*cosd(thetamin1(i));

    kv1_MCms(i)=max((0.4/(1+1500*epsilonx(i)))*(1-(VEd_kontrollsnitt/VRdmax_thetamin1(i))),0);
    
    VRdc1_ms(i)=(kv1_MCms(i)*(min(sqrt(fck(i)),8)/yc)*z*bw);
    
    if VRdc1_ms(i)+VRds1(i) >= VRdmax_thetamin1(i)
        VRd1s_ms(i) = VRds1(i);
    else VRd1s_ms(i)=VRdc1_ms(i)+VRds1(i);
    end

  VRdmax1(i)=kc1(i)*(fck(i)/yc)*bw*z*sind(theta)*cosd(theta);

end
  
  VRd_MCms=(min(VRd1s_ms,VRdmax1))*10^-3;

%% NS3473 
% NY input
hmerket=d-cnom-boyle-kam16/2;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
alpha=90;

for i=1:n
  fcm(i)=min(fck(i)+8,75);
    if fck(i)<=50
        fctm(i)=0.30*(fck(i))^(2/3);
    else fctm(i)=2.12*log(1+(fcm(i)/10));
    end
fctk005(i)=0.7*fctm(i);
end

%fctk005    %Konstruksjonsfasthet for strekk B35 fra EC2 ftn
%fck          % Fra EC2 fcn
%fctm        %Strekkfasthet fra EC2 ftk

ftd=fctk005/yc;

ka=100;
fsk=500;

Ac=bw*h;
Wc1=(1/6)*bw*h^2;

Esk=Es;

  kv1=1.5-d/(1000*1); 
if kv1 > 1.4;
    kv1 = 1.4;
elseif kv1 < 1.0;
    kv1 = 1.0;
else kv1;
end

% Uten skjrarmering
% NS 3473, 12.3.2.1 uten samtidig aksialkraft
Vco1NS=min(0.3*(ftd+((ka*Asl)/(yc*bw*d)))*bw*d*kv1,0.6*ftd*bw*d*kv1); %d,kv
Vcd1uNS=Vco1NS;

% Trykkbrudd
Vccd=min(0.3*fcd*bw*z*(1+cotd(alpha)),0.45*fcd*bw*z);

VRdNS_us=(min(Vcd1uNS,Vccd))*10^-3;

%% Muttoni og Ruiz
%Uten skjrarmering
for i=1:n
    
    MEd_kontrollsnitt=(d/2)*(-0.25*qEd*d+VEd);
    VEd_kontrollsnitt=(VEd-qEd*d/2);
    
    xtrykk(i)=(fyd*Asl)/(0.8*bw*fcd(i));

    MRd(i) = 0.8*bw*xtrykk(i)*fcd(i)*(d-0.8*(xtrykk(i)/2));
   
    dg=16;

    %Uten skjrarmering
    if fck(i) <= 70
        kdg(i) = 1;
    elseif fck(i) > 70
        kdg(i) = 2;
    end

    epsiV=max((1/(Asl*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt),0);
end
    VRdc_MR_us=((0.3./(1+epsiV*d*kdg)).*(min(sqrt(fck),8)/yc)*bw*d)*10^-3;

%Med skjrarmering
theta=45; %velger trykkfeltsvinkel 45 grader TSS.

dkrit=z*cotd(theta)/2;

s=200;
 VRwd_MR=(Asw/s)*fyd*cotd(theta);

for i=1:n
netafc(i)=min((30/fck(i))^(1/3),1.0);
netaepsi=0.55;
nu1(i)=netafc(i)*netaepsi;
end

 VRdcc_MR=bw*z*nu1.*(fcd/(cotd(theta)+tand(theta)));

 VRd_MR_ms=min(VRwd_MR,VRdcc_MR);

%% Mekanisk modell, Clader, Mari

alpha=90;
fcd=fck;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
Ep=195000;
Ap=0;
Ac=bw*h;
sigmacp1=NEd/Ac;   

for i=1:n
    fcm(i)=fck(i)+8;
    Ecm(i)=22*((fcm(i)/10)^(0.3))*10^3;
 if fck(i)<=50
        fctm(i)=0.30*(fck(i))^(2/3);
    else fctm(i)=2.12*log(1+(fcm(i)/10));
 end

%6.2.2(4) 

alphaes(i)=Es/Ecm(i);
alphaep(i)=Ep/Ecm(i);
rhos=Asl/(bw*d);
rhop=Ap/(bw*d);


alphaerhol(i)=alphaes(i)*rhos+alphaep(i)*rhop;
x0(i)=d*0.75*(alphaerhol(i))^(1/3); 

sigmacp=max(NEd/Ac,0);

if     NEd==0
    x(i)=x0(i);
elseif NEd>0
    x(i)=min(x0+0.80*(h-x0(i))*(d/h)*(sigmacp/(sigmacp+fctm(i))),h)
else   NEd<0
    x(i)=max(x0*(1+0.1*(NEd*ds/MEd)),0)
end

cottheta(i)=min(((0.85*d)/(d-x(i))),2.5);   
%cottheta(i)=1;
theta_test(i)=acotd(min(((0.85*d)/(d-x(i))),2.5));
%Uten skjrarmering

a=MEd/VEd; %Kontroller mot a=0.25L
d0=max(d,100);
fcdcu(i)=min(fcd(i),60);
zeta=max((2/sqrt(1+(d0/200)))*(d/a)^0.2,0.45);
%x(i)=1;
kc(i)=min(x(i)/d,0.20);    
bveff=bw;

% Strekkbrudd

Vcu_CM(i)=max(0.3*zeta*(x(i)/d)*((fcdcu(i))^(2/3))*bveff*d,0.25*(zeta*kc(i)+(20/d0))*(fcdcu(i))^(2/3)*bw*d);
testss(i)=x(i)/d;
testss22(i)=(x(i)/d)*fcdcu(i);
Vmmax(i)=0.3*zeta*(x(i)/d)*((fcdcu(i))^(2/3))*bveff*d;
Vmmin(i)=0.25*(zeta*kc(i)+(20/d0))*(fcdcu(i))^(2/3)*bw*d;

    if Vmmax(i)>Vmmin(i);
        v(i)=1;
    else v(i)=2;
    end 

% Trykkbrudd

if sigmacp==0;
    alphacw1(i)=1;
elseif 0 < sigmacp <= 0.25*fcd(i);
    alphacw1(i)=1+sigmacp/fcd(i);
elseif 0.25 < sigmacp < 0.5*fcd(i);
    alphacw1(i)=1.25;
else 0.5 < sigmacp < 1.0*fcd(i);
    alphacw1(i)=2.5*(1-sigmacp/fcd(i));
end

if fck(i)<=60
    nu(i)=0.60;
else nu(i)=max(0.9-(fck(i)/200),0.5);
end

VRdmax_CM(i)=alphacw1(i)*bw*z*nu(i)*fcd(i)*((cottheta(i)+cotd(alpha))/(1+(cottheta(i))^2));

VRd1_CM(i)=Vcu_CM(i);
end

VRd_CM=min(VRd1_CM,VRdmax_CM)*10^-3;
 
%% plot
figure(1),title 'Tverrsnitt med varierende betongkvalitet uten beregningsmessig behov for skjrarmering',axis([axisxmin axisxmax axisymin axisymax])
hold on
plot(fck,VRdc_ECus,'-g')    %EC
plot(fck,VRdc_MCus,'-b')    %MC
plot(fck,VRdNS_us,'-r')     %NS
plot(fck,VRdc_MR_us,'-m')   %MR
plot(fck,VRd_CM,'-black')   %CM
legend 'Kapasitet EC 2' 'Kapasitet MC 2010' 'Kapasitet NS 3473' 'Kapasitet MR' 'Kapasitet CM'
xlabel('20MPa < fck < 95MPa')
ylabel('Skjrkapasitet, VRd [kN]')
hold off

for i=1:n
rhol=Asl/(bw*h);
%rhol=1;
X(i)=0.75*((rhol*Es/Ecm(i))^(1/3))*fcd(i)^(2/3);
Y(i)=(100*rhol*fck(i))^(1/3);
MR(i)=min(sqrt(fck(i)),8)/yc;
fcd(i)=0.85*fck(i)/yc;
CM(i)=(fcd(i)^(2/3))*(rhol*Es/Ecm(i))^(1/3);
EC2(i)=fck(i)^(1/3);
end

figure(2)
hold on
plot(fck,X,'-black')
plot(fck,Y,'-g')
legend 'Cladera-Mari' 'EC 2'
hold off

figure(3)
hold on
plot(fck,CM,'-black')
plot(fck,EC2,'-g')
plot(fck,MR,'-m')
legend 'Cladera-Mari' 'EC 2' 'MR'
hold off