clc
clear all; close all

%INPUT betong
cnom=30;
fck=35;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
dg=16;
%INPUT armering
boyle=10;
kam16=16;
fyk=500;
ys=1;
fyd=fyk/ys;
Asl=804;
Es=200000;
%INPUT tverrsnitt
bw=250;
h=300;
Ac=bw*h;
d=h-cnom-boyle-(kam16/2);
z=0.9*d;
l=6000;
%INPUT laster
qEd=15;

VEd=qEd*0.5*l;
VEd_kontrollsnitt=(VEd-qEd*d);

MEd=(qEd*l^2)/8;
MEd_kontrollsnitt=-0.5*qEd*(d^2)+VEd*d;

NEd=0;
fck=20:1:95;
n=76;

%% EC2
% Input data

alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
fyd=500;
theta=45;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
sw=s;
%NS-EN 1992-1-1, 6.2.3(3) Med beregningsmessig behov for skjrarmering
% Husk vinkelbegrensninger med strekk
%Strekkbrudd
VRds1_EC2=(Asw/s)*z*fyd*cotd(theta);

%Trykkbrudd
sigmacp1=NEd/Ac;             
for i=1:n
if 0 < sigmacp1 <= 0.25*fcd(i);
    alphacw1=1+sigmacp1/fcd(i);
elseif 0.25 < sigmacp1 < 0.5*fcd(i);
    alphacw1=1.25;
else 0.5 < sigmacp1 < 1.0*fcd(i);
    alphacw1=2.5*(1-sigmacp1/fcd(i));
end

nu(i)=0.6*(1-fck(i)/250);

VRdmax_EC2(i)=alphacw1*bw*z*nu(i)*fcd(i)/(cotd(theta)+tand(theta));

end

VRd_EC2=min(VRds1_EC2,VRdmax_EC2);

%% Model Code
for i=1:n
   if NEd == 0;
       deltae1(i)=0;
   else if MEd1/NEd >= h/2;
         deltae1(i) = h/2;
        elseif MEd_kontrollsnitt/NEd <= -h/2;
         deltae1(i) = -h/2;
        else deltae1(i) = MEd_kontrollsnitt/NEd;
       end
   end
    
    epsilonx_formel(i)=max((1/(2*Asl*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt+(NEd*(0.5+(deltae1(i)/z)))),0);
    
    if (MEd_kontrollsnitt/z) < NEd;
        epsilonx(i) = 2 * min(epsilonx_formel(i),0.003);
    else (MEd_kontrollsnitt/z) >= NEd;
        epsilonx(i) = min(epsilonx_formel(i),0.003);
    end
    
  % Uten skjrarmering
  
    if fck(i) <= 70;
        dg(i) = 16;
    else fck(i) > 70;
        dg(i) = 0;
    end

    kdg(i)=max(32/(16+dg(i)),0.75);
    
    kv1_MCus(i)=((0.4)/(1+1500*epsilonx(i)))*((1300)/(1000+kdg(i)*z));
   
    VRdc_MCus(i)=max((kv1_MCus(i)*(min(sqrt(fck(i)),8)/yc)*z*bw)*10^-3,0);

    % Med skjrarmering
    theta=45; %vinkel trykkfelt, 45 grader TSS
    Asw=2*pi*(boyle/2)^2;
    sw=200;
    netafc(i)=max((30/fck(i))^(1/3),1.0);

    thetamin1(i)=20+10000*epsilonx(i);

    epsilon11(i)=epsilonx(i)+(epsilonx(i)+0.002)*((1/tand(thetamin1(i)))^2);

    kepsi1(i)=min(1/(1.2+55*epsilon11(i)),0.65);

    kc1(i)=kepsi1(i)*netafc(i);

    cotan_theta=1/tand(theta);
    VRds1(i)=(Asw/sw)*z*fyd*cotan_theta;

    VRdmax_thetamin1(i)=kc1(i)*(fck(i)/yc)*bw*z*sind(thetamin1(i))*cosd(thetamin1(i));

    kv1_MCms(i)=max((0.4/(1+1500*epsilonx(i)))*(1-(VEd_kontrollsnitt/VRdmax_thetamin1(i))),0);
    
    VRdc1_ms(i)=(kv1_MCms(i)*(min(sqrt(fck(i)),8)/yc)*z*bw);

    
    if VRdc1_ms(i)+VRds1(i) >= VRdmax_thetamin1(i)
        VRd1s_ms(i) = VRds1(i);
    else VRd1s_ms(i)=VRdc1_ms(i)+VRds1(i);
    end

  VRdmax1(i)=kc1(i)*(fck(i)/yc)*bw*z*sind(theta)*cosd(theta);

end
  
  VRd_MCms=(min(VRd1s_ms,VRdmax1))*10^-3;



%% NS3473 
% NY input
hmerket=d-cnom-boyle-kam16/2;



for i=1:n
  fcm(i)=min(fck(i)+8,75);
    if fck(i)<=50
        fctm(i)=0.30*(fck(i))^(2/3);
    else fctm(i)=2.12*log(1+(fcm(i)/10));
    end
fctk005(i)=0.7*fctm(i);
end

%fctk005    %Konstruksjonsfasthet for strekk B35 fra EC2 ftn
%fck          % Fra EC2 fcn
%fctm        %Strekkfasthet fra EC2 ftk

ftd=fctk005/yc;
fcd=fck/yc;

ka=100;
fsk=500;

Ac=bw*h;
Wc1=(1/6)*bw*h^2;

Esk=Es;

  kv1=1.5-d/(1000*1); 
if kv1 > 1.4;
    kv1 = 1.4;
elseif kv1 < 1.0;
    kv1 = 1.0;
else kv1;
end
kv1=1.0; % settes lik i med skjrarmering 

% Uten skjrarmering
% NS 3473, 12.3.2.1 uten samtidig aksialkraft
Vco1NS=min(0.3*(ftd+((ka*Asl)/(yc*bw*d)))*bw*d*kv1,0.6*ftd*bw*d*kv1); %d,kv
Vcd1uNS=Vco1NS;

Ic1=(1/12)*bw*h^3;
Sc1=bw*h*h/2; 
z11=max(0.7*d,Ic1/Sc1);

% Med skjrarmering
% NS 3473, 12.3.2.4 Konstruksjonsdeler med skjrarmering
fsk=500;
fsd=fsk/ys;
alpha=90; %vertikal byler

% Strekkbrudd med aksialstrekk
Vsd1NS=(fsd*Asw/s)*z*(1+cotd(alpha))*sind(alpha);

% Trykkbrudd
Vccd=min(0.3*fcd*bw*z*(1+cotd(alpha)),0.45*fcd*bw*z);

%NS 3473 18.3.6 Minimum skjrarmering i bjelker
Asmin1=0.2*Ac*fctm*sind(alpha)/fsk;     

%NS 3473 12.3.1.2 (Vcd+Vsd) 
%Uten aksialkraft
if Asl>Asmin1;
    VRd1NS=Vcd1uNS+Vsd1NS;
else VRd1NS=Vcd1uNS;
end 

VRdNS=min(VRd1NS,Vccd);

%% Muttoni og Ruiz
%Uten skjrarmering
for i=1:n
    
    MEd_kontrollsnitt=(d/2)*(-0.25*qEd*d+VEd);
    VEd_kontrollsnitt=(VEd-qEd*d/2);
    
    xbal=0.617*d;
    xtrykk(i)=(fyd*Asl)/(0.8*bw*fcd(i));

    %if xtrykk(i) <= xbal
        %MRd(i) = 0.275*bw*fcd(i)*d^2;
    %else 
    MRd(i) = 0.8*bw*xtrykk(i)*fcd(i)*(d-0.8*(xtrykk(i)/2));
    %end

    dg=16;

    %Uten skjrarmering
    if fck(i) > 70
        kdg(i) = 2;
    elseif fck(i) <= 70
        kdg(i) = 1;
    end

    %if dg >= 16
     %   kdg(i) = 32/(16+dg);
    %else kdg(i);
    %end

    epsiV=max((NEd+MEd_kontrollsnitt/z)/(Asl*Es),0);

    
end
    VRdc_MR_us=((0.3./(1+epsiV*d.*kdg)).*(min(sqrt(fck),8)/yc)*bw*d)*10^-3;

%Med skjrarmering
theta=45; %velger trykkfeltsvinkel 45 grader TSS.

dkrit=z*cotd(theta)/2;

s=200;
VRwd_MR=((Asw/s)*z*fyd*cotd(theta))*10^-3;

for i=1:n
netafc(i)=min((30/fck(i))^(1/3),1.0);
netaepsi=0.55; 
nu1(i)=netafc(i)*netaepsi;
end

VRdcc_MR=(bw*z*nu1.*(fcd/(cotd(theta)+tand(theta))))*10^-3;

VRd_MR_ms=min(VRwd_MR,VRdcc_MR);
%% Mekanisk modell, Clader, Mari

alpha=90;
fcd=fck;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
Ep=195000;
Ap=0;
Ac=bw*h;
sigmacp1=NEd/Ac;   

for i=1:n
    fcm(i)=fck(i)+8;
    Ecm(i)=22*((fcm(i)/10)^(0.3))*10^3;
 if fck(i)<=50
        fctm(i)=0.30*(fck(i))^(2/3);
    else fctm(i)=2.12*log(1+(fcm(i)/10));
 end

%6.2.2(4) 

alphaes(i)=Es/Ecm(i);
alphaep(i)=Ep/Ecm(i);
rhos=Asl/(bw*d);
rhop=Ap/(bw*d);


alphaerhol(i)=alphaes(i)*rhos+alphaep(i)*rhop;
x0(i)=d*0.75*(alphaerhol(i))^(1/3);

sigmacp=max(NEd/Ac,0);

if     NEd==0
    x(i)=x0(i);
elseif NEd>0
    x(i)=min(x0+0.80*(h-x0(i))*(d/h)*(sigmacp/(sigmacp+fctm(i))),h)
else   NEd<0
    x=max(x0*(1+0.1*(NEd*ds/MEd)),0)
end

%cottheta(i)=min(((0.85*d)/(d-x(i))),2.5);   
cottheta(i)=1;
theta_test(i)=acotd(min(((0.85*d)/(d-x(i))),2.5));
%Uten skjrarmering

a=MEd/VEd; %Kontroller mot a=0.25L
d0=max(d,100);
fcdcu(i)=min(fcd(i),60);
zeta=max((2/sqrt(1+(d0/200)))*(d/a)^0.2,0.45);
%x(i)=1;
kc(i)=min(x(i)/d,0.20);    
bveff=bw;

% Strekkbrudd

Vcu_CM(i)=max(0.3*zeta*(x(i)/d)*((fcdcu(i))^(2/3))*bveff*d,0.25*(zeta*kc(i)+(20/d0))*(fcdcu(i))^(2/3)*bw*d);
testss(i)=x(i)/d;
testss22(i)=(x(i)/d)*fcdcu(i);
Vmmax(i)=0.3*zeta*(x(i)/d)*((fcdcu(i))^(2/3))*bveff*d;
Vmmin(i)=0.25*(zeta*kc(i)+(20/d0))*(fcdcu(i))^(2/3)*bw*d;

    if Vmmax(i)>Vmmin(i);
        v(i)=1;
    else v(i)=2;
    end 

% Trykkbrudd

if sigmacp==0;
    alphacw1(i)=1;
elseif 0 < sigmacp <= 0.25*fcd(i);
    alphacw1(i)=1+sigmacp/fcd(i);
elseif 0.25 < sigmacp < 0.5*fcd(i);
    alphacw1(i)=1.25;
else 0.5 < sigmacp < 1.0*fcd(i);
    alphacw1(i)=2.5*(1-sigmacp/fcd(i));
end

if fck(i)<=60
    nu(i)=0.60;
else
nu(i)=max(0.9-(fck(i)/200),0.5);
end

VRdmax_CM(i)=alphacw1(i)*bw*z*nu(i)*fcd(i)*((cottheta(i)+cotd(alpha))/(1+(cottheta(i))^2));

%Med skjrarmering
ds=d;
Vsu_CM(i)=1.4*(Asw/s)*fyd*(ds-x(i))*sind(alpha)*(cottheta(i)+cotd(alpha));

VRd_CM(i)=Vcu_CM(i)+Vsu_CM(i);
end

VRd_CM=min(VRd_CM,VRdmax_CM)*10^-3;


%% Plot
figure(1),title 'Tverrsnitt med varierende betongkvalitet med beregningsmessig behov for skjrarmering',axis([20 95 0 300])
hold on
plot(fck,VRd_EC2*10^-3,'-g')    %EC2
plot(fck,VRd_MCms,'-b')         %MC
plot(fck,VRdNS*10^-3,'-r')      %NS 
plot(fck,VRd_MR_ms,'--m')
plot(fck,VRd_CM,'-black')      
legend 'Kapasitet EC 2' 'Kapasitet MC 2010' 'Kapasitet NS 3473' 'Kapasitet MR' 'Kapasitet CM'
xlabel('20MPa < fck < 95MPa')
ylabel('Skjrkapasitet, VRd [kN]')

hold off





  
  


