clc
clear all; close all

%% Generell Input
%INPUT betong
fck=35;
cnom=30;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
theta=45; %vinkel trykkfelt, 45 grader TSS
%INPUT armering
kam16=16;
fyk=500;
ys=1;
fyd=fyk/ys;
Asl=804;
Es=200000;
%INPUT tverrsnitt
bw=1000;
h=270;
d=h-cnom-(kam16/2);
z=0.9*d;
l=6000;
Ac=bw*d;
%INPUT laster
qEd=15;
VEd=qEd*0.5*l;
MEd=qEd*l*l/8;
NEd=0;

%% EC2

% Uten skjrarmering
k2=0.18;
CRdc=k2/yc;
k=min(1+(sqrt(200/d)),2.0);
rhol=min(Asl/(bw*d),0.02);

nu=0.6*(1-fck/250);

vmin=0.035*(k^(3/2))*sqrt(fck);
    
VRdcs=max((CRdc*k*((100*rhol*fck)^(1/3)))*bw*d,(vmin)*bw*d);
   
VRdcc=0.5*bw*d*nu*fcd;

VRdc_EC2_uten=min(max(VRdcs,0),VRdcc)*10^-3;

%% Model Code
VEd_kontrollsnitt=(VEd-qEd*d);
MEd_kontrollsnitt=-0.5*qEd*(d^2)+VEd*d;

epsilonX=max((1/(2*Asl*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt),0);

% Uten skjrarmering
  
    if fck <= 70;
        dg = 16;
    else fck > 70;
        dg = 0;
    end

kdg=max(32/(16+dg),0.75);
    
kv1_MCus=((0.4)/(1+1500*epsilonX))*((1300)/(1000+kdg*z));
   
VRdc_MC_uten=max((kv1_MCus*(min(sqrt(fck),8)/yc)*z*bw)*10^-3,0);

%% NS3473 
% NY input

fcm=fck+8;
if fck<=50
    fctm=0.30*(fck)^(2/3);
else fctm=2.12*log(1+(fcm/10));
end
fctk005=0.7*fctm;

%fctk005    %Konstruksjonsfasthet for strekk B35 fra EC2 ftn
%fck          % Fra EC2 fcn
%fctm        %Strekkfasthet fra EC2 ftk

ftd=fctk005/yc;
fcd=fck/yc;

ka=100;
fsk=500;

Ac=bw*h;
Wc1=(1/6)*bw*h^2;

Esk=Es;

kv1=1.5-d/(1000*1); 
if kv1 > 1.4;
    kv1 = 1.4;
elseif kv1 < 1.0;
    kv1 = 1.0;
else kv1;
end

% Uten skjrarmering
% NS 3473, 12.3.2.1 uten samtidig aksialkraft
Vco1NS=min(0.3*(ftd+((ka*Asl)/(yc*bw*d)))*bw*d*kv1,0.6*ftd*bw*d*kv1); %d,kv
Vcd1NS_uten=Vco1NS;
alpha=90;

% Trykkbrudd
Vccd=min(0.3*fcd*bw*z*(1+cotd(alpha)),0.45*fcd*bw*z);  

VRdNS_uten=min(Vcd1NS_uten,Vccd)*10^-3;

%% Muttoni og Ruiz
%Uten skjrarmering

dkrit=0.5*d;
VEd_kontrollsnitt=(VEd-qEd*dkrit);
MEd_kontrollsnitt=-0.5*qEd*(dkrit^2)+VEd*dkrit;

xtrykk=(fyd*Asl)/(0.8*bw*fcd);

MRd=0.8*bw*xtrykk*fcd*(d-0.8*(xtrykk/2));

dg=16;

%Uten skjrarmering
    if fck > 70
        kdg = 2;
    elseif fck <= 70
        kdg = 1;
    end

epsiV=max((1/(Asl*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt),0);

VRdc_MR_uten=((0.3/(1+epsiV*d*kdg))*(min(sqrt(fck),8)/yc)*bw*d)*10^-3;

%% Mekanisk modell, Clader, Mari

alpha=90;
fcd=fck;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
Ep=195000;
Ap=0;
Ac=bw*h;
sigmacp1=NEd/Ac;   


    fcm=fck+8;
    Ecm=22*((fcm/10)^(0.3))*10^3;
 if fck<=50
        fctm=0.30*(fck)^(2/3);
    else fctm=2.12*log(1+(fcm/10));
 end

%6.2.2(4) 

alphaes=Es/Ecm;
alphaep=Ep/Ecm;
rhos=Asl/(bw*d);
rhop=Ap/(bw*d);


alphaerhol=alphaes*rhos+alphaep*rhop;
x0=d*0.75*(alphaerhol)^(1/3);       
sigmacp=max(NEd/Ac,0);

if     NEd==0
    x=x0;
elseif NEd>0
    x=min(x0+0.80*(h-x0)*(d/h)*(sigmacp/(sigmacp+fctm)),h);
else   NEd<0
    x=max(x0*(1+0.1*(NEd*ds/MEd)),0);
end

%cottheta=min(((0.85*d)/(d-x)),2.5);   
cottheta=1;
theta_test=acotd(min(((0.85*d)/(d-x)),2.5));
%Uten skjrarmering

a=MEd/VEd; %Kontroller mot a=0.25L
d0=max(d,100);
fcdcu=min(fcd,60);
zeta=max((2/sqrt(1+(d0/200)))*(d/a)^0.2,0.45);
%x=1;
kc=min(x/d,0.20);    
bveff=bw;

% Strekkbrudd

Vcu_CM=max(0.3*zeta*(x/d)*((fcdcu)^(2/3))*bveff*d,0.25*(zeta*kc+(20/d0))*(fcdcu)^(2/3)*bw*d);
testss=x/d;
testss22=(x/d)*fcdcu;
Vmmax=0.3*zeta*(x/d)*((fcdcu)^(2/3))*bveff*d;
Vmmin=0.25*(zeta*kc+(20/d0))*(fcdcu)^(2/3)*bw*d;

    if Vmmax>Vmmin;
        v=1;
    else v=2;
    end 

% Trykkbrudd

if sigmacp==0;
    alphacw1=1;
elseif 0 < sigmacp <= 0.25*fcd;
    alphacw1=1+sigmacp/fcd;
elseif 0.25 < sigmacp < 0.5*fcd;
    alphacw1=1.25;
else 0.5 < sigmacp < 1.0*fcd;
    alphacw1=2.5*(1-sigmacp/fcd);
end

if fck<=60
    nu=0.60;
else
    nu=max(0.9-(fck/200),0.5);
end

VRdmax_CM=alphacw1*bw*z*nu*fcd*((cottheta+cotd(alpha))/(1+(cottheta)^2));

VRd_CM_uten=min(Vcu_CM,VRdmax_CM)*10^-3;

%% Tabell
Oversikt_uten=table(VRdc_EC2_uten,VRdc_MC_uten,VRdNS_uten,VRdc_MR_uten,VRd_CM_uten)
