clc
clear all; close all

%INPUT betong
cnom=30;
fck=35;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
dg=16;
%INPUT armering
boyle=10;
kam16=16;
fyk=500;
ys=1;
fyd=fyk/ys;
Asl=100:1:3000;
Es=200000;
%INPUT tverrsnitt
bw=250;
h=300;
Ac=bw*h;
d=h-cnom-boyle-(kam16/2);
z=0.9*d;
l=6000;
%INPUT laster
qEd=15;

VEd=qEd*0.5*l;
VEd_kontrollsnitt=(VEd-qEd*d);

MEd=(qEd*l^2)/8;
MEd_kontrollsnitt=-0.5*qEd*(d.^2)+VEd*d;

NEd=0;
n=2901;

%% EC2
%Input data
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
sw=s;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
fyd=500;
theta=45;

%NS-EN 1992-1-1, 6.2.3(3) Med beregningsmessig behov for skjrarmering
%Husk vinkelbegrensninger med strekk
%Strekkbrudd
for i=1:n
VRds1_EC2(i)=(Asw/s)*z*fyd*cotd(theta);

%Trykkbrudd          
    sigmacp1=NEd/Ac;
if 0 < sigmacp1 <= 0.25*fcd; 
    alphacw1=1+sigmacp1/fcd;
elseif 0.25 < sigmacp1(i) < 0.5*fcd;
    alphacw1=1.25;
else 0.5 < sigmacp1 < 1.0*fcd;
    alphacw1=2.5*(1-sigmacp1/fcd);
end

nu=0.6*(1-fck/250);

VRdmax_EC2(i)=alphacw1*bw*z*nu*fcd/(cotd(theta)+tand(theta));

VRd_EC2(i)=min(VRds1_EC2(i),VRdmax_EC2(i));
end

%% Model Code
for i=1:n
   if NEd == 0;
       deltae1=0;
   else if MEd_kontrollsnitt/NEd >= h/2;
         deltae1 = h/2;
        elseif MEd_kontrollsnitt/NEd <= -h/2;
         deltae1 = -h(i)/2;
        else deltae1 = MEd_kontrollsnitt/NEd;
       end
   end
    
    epsilonx_formel(i)=max((1/(2*Asl(i)*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt+(NEd*(0.5+(deltae1/z)))),0);
    
    if (MEd_kontrollsnitt/z) < NEd;
        epsilonx(i) = 2 * min(epsilonx_formel(i),0.003);
    else (MEd_kontrollsnitt/z) >= NEd;
        epsilonx(i) = min(epsilonx_formel(i),0.003);
    end
    
  % Uten skjrarmering
  
    if fck <= 70;
        dg = 16;
    else fck > 70;
        dg = 0;
    end

    kdg=max(32/(16+dg),0.75);
    
    kv1_MCus(i)=((0.4)/(1+1500*epsilonx(i)))*((1300)/(1000+kdg*z));
   
    VRdc_MCus(i)=max((kv1_MCus(i)*(min(sqrt(fck),8)/yc)*z*bw)*10^-3,0);

  % Med skjrarmering
    theta=45; %vinkel trykkfelt, 45 grader TSS
    Asw=2*pi*(boyle/2)^2;
    sw=200;
    netafc=max((30/fck)^(1/3),1.0);

    thetamin1(i)=20+10000*epsilonx(i);

    epsilon11(i)=epsilonx(i)+(epsilonx(i)+0.002)*((1/tand(thetamin1(i)))^2);

    kepsi1(i)=min(1/(1.2+55*epsilon11(i)),0.65);

    kc1(i)=kepsi1(i)*netafc;

    VRds1(i)=(Asw/sw)*z*fyd*cotd(theta);

    VRdmax_thetamin1(i)=kc1(i)*(fck/yc)*bw*z*sind(thetamin1(i))*cosd(thetamin1(i));

    kv1_MCms(i)=max((0.4/(1+1500*epsilonx(i)))*(1-(VEd_kontrollsnitt/VRdmax_thetamin1(i))),0);
    
    VRdc1_ms(i)=(kv1_MCms(i)*(min(sqrt(fck),8)/yc)*z*bw);
   
    if VRdc1_ms(i)+VRds1(i) >= VRdmax_thetamin1(i)
        VRd_MCms(i) = VRds1(i);
    else VRd_MCms(i)=VRdc1_ms(i)+VRds1(i);
    end

  VRdmax1(i)=kc1(i)*(fck/yc)*bw*z*sind(theta)*cosd(theta);


  
  VRd_MCms(i)=(min(VRd_MCms(i),VRdmax1(i)))*10^-3;
  end
%% NS3473 
% NY input

fcm=fck+8;
    if fck<=50
        fctm=0.30*(fck)^(2/3);
    else fctm=2.12*log(1+(fcm/10));
    end
fctk005=0.7*fctm;


%fctk005    %Konstruksjonsfasthet for strekk B35 fra EC2 ftn
%fck        %Fra EC2 fcn
%fctm       %Strekkfasthet fra EC2 ftk

ftd=fctk005/yc;
fcd=fck/yc;

ka=100;
fsk=500;


Ac=bw*h;
Wc1=(1/6)*bw*h^2;

Esk=Es;

  kv1=1.5-d/(1000*1); 
if kv1 > 1.4;
    kv1 = 1.4;
elseif kv1 < 1.0;
    kv1 = 1.0;
else kv1;
end
kv1=1.0; % settes lik i med skjrarmering 

% Uten skjrarmering
% NS 3473, 12.3.2.1 uten samtidig aksialkraft

for i=1:n
Vco1NS(i)=min(0.3*(ftd+((ka*Asl(i))/(yc*bw*d)))*bw*d*kv1,0.6*ftd*bw*d*kv1); %d,kv
Vcd1uNS(i)=Vco1NS(i);


Ic1=(1/12)*bw*h^3;
Sc1=bw*(h^2)/2; 
z11=max(0.7*d,Ic1/Sc1);

% Med skjrarmering
% NS 3473, 12.3.2.4 Konstruksjonsdeler med skjrarmering
fsk=500;
fsd=fsk/ys;
alpha=90; %vertikal byler

% Strekkbrudd med aksialstrekk
Vsd1NS(i)=(fsd*Asw./s)*z*(1+cotd(alpha))*sind(alpha);

% Trykkbrudd
Vccd=min(0.3*fcd*bw*z*(1+cotd(alpha)),0.45*fcd*bw*z);

%NS 3473 18.3.6 Minimum skjrarmering i bjelker
Asmin1=0.2*Ac*fctm*sind(alpha)/fsk;     

%NS 3473 12.3.1.2 (Vcd+Vsd) 
%Uten aksialkraft
if Asl(i)>Asmin1;
    VRd1NS(i)=Vcd1uNS(i)+Vsd1NS(i);
else VRd1NS(i)=Vcd1uNS(i);
end 

VRdNS(i)=min(VRd1NS(i),Vccd);
end 

%% Muttoni og Ruiz
%Uten skjrarmering
for i=1:n
    
    dkrit=d/2;
    MEd_kontrollsnitt=(-qEd*0.5*dkrit+VEd)*dkrit;
    VEd_kontrollsnitt=(VEd-qEd*dkrit);
    
    xtrykk(i)=(fyd*Asl(i))/(0.8*bw*fcd);

    MRd(i) = 0.8*bw*xtrykk(i)*fcd*(d-(0.8*xtrykk(i)/2));
    
    %Uten skjrarmering

    if dg >= 16
        kdg = 32/(16+dg);
    else kdg = 1.0;
    end


%Med skjrarmering
theta=45; %velger trykkfeltsvinkel 45 grader TSS.

dkrit=z*cotd(theta)/2;

Asw=2*pi*(boyle/2)^2;
s=200;
VRwd_MR=((Asw/s)*z*fyd*cotd(theta))*10^-3;

netafc=min((30/fck)^(1/3),1.0);
netaepsi=0.55;
nu1=netafc*netaepsi;

VRdcc_MR=(bw*z*nu1.*(fcd/(cotd(theta)+tand(theta))))*10^-3;

VRd_MR_ms(i)=min(VRwd_MR,VRdcc_MR);
end

%% Mekanisk modell, Clader, Mari
alpha=90;
fcd=fck;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
Ep=195000;
Ap=0;
Ac=bw*h;
sigmacp1=NEd/Ac;   

for i=1:n
    fcm=fck+8;
    Ecm=22*((fcm/10)^(0.3))*10^3;
 if fck<=50
        fctm=0.30*(fck)^(2/3);
    else fctm=2.12*log(1+(fcm/10));
 end

%6.2.2(4) 

alphaes(i)=Es/Ecm;
alphaep(i)=Ep/Ecm;
rhos(i)=Asl(i)/(bw*d);
rhop(i)=Ap/(bw*d);


alphaerhol(i)=alphaes(i)*rhos(i)+alphaep(i)*rhop(i);
x0(i)=d*0.75*(alphaerhol(i))^(1/3);

sigmacp=max(NEd/Ac,0);

if     NEd==0
    x(i)=x0(i);
elseif NEd>0
    x(i)=min(x0(i)+0.80*(h-x0(i))*(d/h)*(sigmacp/(sigmacp+fctm)),h)
else   NEd<0
    x(i)=max(x0(i)*(1+0.1*(NEd*ds/MEd)),0)
end

%cottheta(i)=min(((0.85*d)/(d-x(i))),2.5);  
cottheta(i)=1;
theta_test(i)=acotd(min(((0.85*d)/(d-x(i))),2.5));
%Uten skjrarmering

a=MEd/VEd; %Kontroller mot a=0.25L
d0=max(d,100);
fcdcu=min(fcd,60);
zeta=max((2/sqrt(1+(d0/200)))*(d/a)^0.2,0.45);
%x(i)=1;
kc(i)=min(x(i)/d,0.20); %kc=0.20 fra og med celle 105->Asl=205
bveff=bw;

% Strekkbrudd

Vcu_CM(i)=max(0.3*zeta*(x(i)/d)*((fcdcu)^(2/3))*bveff*d,0.25*(zeta*kc(i)+(20/d0))*(fcdcu)^(2/3)*bw*d);
   %Bytter fra Vmmin til Vmmax fra og med celle 243->Asl=343
Vmmax(i)=0.3*zeta*(x(i)/d)*((fcdcu)^(2/3))*bveff*d;
Vmmin(i)=0.25*(zeta*kc(i)+(20/d0))*(fcdcu)^(2/3)*bw*d;

    if Vmmax(i)>Vmmin(i);
        v(i)=1;
    else v(i)=2;
    end 

% Trykkbrudd

if sigmacp1==0;
    alphacw1(i)=1;
elseif 0 < sigmacp1 <= 0.25*fcd(i);   
    alphacw1(i)=1+sigmacp1/fcd(i);
elseif 0.25 < sigmacp1 < 0.5*fcd(i);
    alphacw1(i)=1.25;
else 0.5 < sigmacp1 < 1.0*fcd(i);
    alphacw1(i)=2.5*(1-sigmacp1/fcd(i));
end

if fck<=60
    nu(i)=0.60;
else
nu(i)=max(0.9-(fck/200),0.5);
end

VRdmaxCM(i)=alphacw1(i)*bw*z*nu(i)*fcd*((cottheta(i)+cotd(alpha))/(1+(cottheta(i))^2));

%Med skjrarmering
ds=d;
Vsu_CM(i)=1.4*(Asw/s)*fyd*(ds-x(i))*sind(alpha)*(cottheta(i)+cotd(alpha));
%minker pga. x ker med Asl 

VRd_CM(i)=Vcu_CM(i)+Vsu_CM(i);
%test(i)=(ds-x(i))*cottheta(i);
VRd_CM(i)=min(VRd_CM(i),VRdmaxCM(i))*10^-3;
end
%% Plot
figure(1),title 'Tverrsnitt med varierende lengdearmering med beregningsmessig behov for skjrarmering',axis([0 3000 0 300])
hold on
plot(Asl,VRd_EC2*10^-3,'-g')    %EC2
plot(Asl,VRd_MCms,'-b')         %MC
plot(Asl,VRdNS*10^-3,'-r')      %NS      
plot(Asl,VRd_MR_ms,'--m')      
plot(Asl,VRd_CM,'-black') 
legend 'Kapasitet EC 2' 'Kapasitet MC 2010' 'Kapasitet NS 3473' 'Kapasitet MR' 'Kapasitet CM'
xlabel('100mm^2 < Asl < 3000mm^2')
ylabel('Skjrkapasitet, VRd [kN]')
hold off