clc
clear all; close all

%% Generell Input
%INPUT betong
fck=35;
cnom=30;
alfacc=1;
yc=1;
fcd=alfacc*(fck/yc);
%INPUT armering
boyle=10;
kam16=16;
fyk=500;
ys=1;
fyd=fyk/ys;
Es=200000;

Xend=3000;
Xstart=100;
step=1;
Asl=Xstart:step:Xend;
n=((Xend-Xstart)/step)+1;
axisxmin=0;
axisxmax=Xend;
axisymin=0;
axisymax=300;

%INPUT tverrsnitt
h=300;
bw=250;
d=h-cnom-boyle-(kam16/2);
z=0.9*d;
l=6000;
%INPUT laster
qEd=15;
VEd=qEd*0.5*l;
MEd=qEd*l*l/8;
VEd_kontrollsnitt=(VEd-qEd*d);
MEd_kontrollsnitt=-0.5*qEd*(d^2)+VEd*d;
NEd=0;

%% EC2
% Uten skjrarmering
k2=0.18;
CRdc=k2/yc;
k=min(1+(sqrt(200/d)),2.0);
Ac=h*bw;
sigmacp=min(NEd/Ac,0.2*fcd);   
nu=0.6*(1-fck/250);
vmin=0.035*(k^(3/2))*sqrt(fck);

for i=1:n
    
    rhol(i)=min(Asl(i)/(bw*d),0.02);
    
    if NEd <= 0
        k1_ECus = 0.3;
    else NEd > 0
        k1_ECus = 0.15;
    end
    
    VRdcs(i)=max((CRdc*k*((100*rhol(i)*fck)^(1/3))+k1_ECus*sigmacp)*bw*d,(vmin+k1_ECus*sigmacp)*bw*d);
   
    VRdcc(i)=0.5*bw*d*nu*fcd;

    VRdc_ECus(i)=min(max(VRdcs(i),0),VRdcc(i))*10^-3;
    
end

%% Model Code
for i=1:n
   if NEd == 0;
       deltae1=0;
   else if MEd_kontrollsnitt/NEd >= h/2;
         deltae1 = h/2;
        elseif MEd_kontrollsnitt/NEd <= -h/2;
         deltae1 = -h(i)/2;
        else deltae1 = MEd_kontrollsnitt/NEd;
       end
   end
    
    epsilonx_formel(i)=max((1/(2*Asl(i)*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt+(NEd*(0.5+(deltae1/z)))),0);
    
    if (MEd_kontrollsnitt/z) < NEd;
        epsilonx(i) = 2 * min(epsilonx_formel(i),0.003);
    else (MEd_kontrollsnitt/z) >= NEd;
        epsilonx(i) = min(epsilonx_formel(i),0.003);
    end
  
  % Uten skjrarmering
  
    if fck <= 70;
        dg = 16;
    else fck > 70;
        dg = 0;
    end

    kdg=max(32/(16+dg),0.75);
    
    kv1_MCus(i)=((0.4)/(1+1500*epsilonx(i)))*((1300)/(1000+kdg*z));
   
    VRdc_MCus(i)=max((kv1_MCus(i)*(min(sqrt(fck),8)/yc)*z*bw)*10^-3,0);

  % Med skjrarmering
    theta=45; %vinkel trykkfelt, 45 grader TSS
    Asw=2*pi*(boyle/2)^2;
    sw=200;
    netafc=max((30/fck)^(1/3),1.0);

    thetamin1(i)=20+10000*epsilonx(i);

    epsilon11(i)=epsilonx(i)+(epsilonx(i)+0.002)*((1/tand(thetamin1(i)))^2);

    kepsi1(i)=min(1/(1.2+55*epsilon11(i)),0.65);

    kc1(i)=kepsi1(i)*netafc;

    VRds1(i)=(Asw/sw)*z*fyd*cotd(theta);

    VRdmax_thetamin1(i)=kc1(i)*(fck/yc)*bw*z*sind(thetamin1(i))*cosd(thetamin1(i));

    kv1_MCms(i)=max((0.4/(1+1500*epsilonx(i)))*(1-(VEd_kontrollsnitt/VRdmax_thetamin1(i))),0);
    
    VRdc1_ms(i)=(kv1_MCms(i)*(min(sqrt(fck),8)/yc)*z*bw);
   
    if VRdc1_ms(i)+VRds1(i) >= VRdmax_thetamin1(i)
        VRd_MCms(i) = VRds1(i);
    else VRd_MCms(i)=VRdc1_ms(i)+VRds1(i);
    end

  VRdmax1(i)=kc1(i)*(fck/yc)*bw*z*sind(theta)*cosd(theta);

end

  VRd_MCms=(min(VRd_MCms,VRdmax1))*10^-3;

%% NS3473 
% NY input
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler

fcm=fck+8;
    if fck<=50
        fctm=0.30*(fck)^(2/3);
    else fctm=2.12*log(1+(fcm/10));
    end
fctk005=0.7*fctm;

%fctk005    %Konstruksjonsfasthet for strekk B35 fra EC2 ftn
%fck        %Fra EC2 fcn
%fctm       %Strekkfasthet fra EC2 ftk

ftd=fctk005/yc;
ka=100;

  kv1=1.5-d/(1000*1); 
if kv1 > 1.4;
    kv1 = 1.4;
elseif kv1 < 1.0;
    kv1 = 1.0;
else kv1;
end

% Uten skjrarmering
for i=1:n
Vco1NS(i)=min(0.3*(ftd+((ka*Asl(i))/(yc*bw*d)))*bw*d*kv1,0.6*ftd*bw*d*kv1); %d,kv
Vcd1uNS(i)=Vco1NS(i);

alpha=90; %vertikal byler

% Trykkbrudd
Vccd=min(0.3*fcd*bw*z*(1+cotd(alpha)),0.45*fcd*bw*z);

VRdNS_us(i)=(min(Vcd1uNS(i),Vccd))*10^-3;
end 

%% Muttoni og Ruiz
%Uten skjrarmering
for i=1:n
    
    dkrit=d/2;
    MEd_kontrollsnitt=(-qEd*0.5*dkrit+VEd)*dkrit
    VEd_kontrollsnitt=(VEd-qEd*dkrit);
    
    %Uten skjrarmering

    if dg >= 16
        kdg = 32/(16+dg);
    else kdg = 1.0;
    end

    epsiV(i)=max((1/(Asl(i)*Es))*((MEd_kontrollsnitt/z)+VEd_kontrollsnitt),0);
end
    VRdc_MR_us=((0.3./(1+epsiV*d*kdg))*(min(sqrt(fck),8)/yc)*bw*d)*10^-3;

%% Mekanisk modell, Clader, Mari
alpha=90;
fcd=fck;
Asw=2*78.539;       %skjrarmering
s=200;              %avstand mellom skjrarmeringsbyler
Ep=195000;
Ap=0;
Ac=bw*h;
sigmacp1=NEd/Ac;   

for i=1:n
    fcm=fck+8;
    Ecm=22*((fcm/10)^(0.3))*10^3;
 if fck<=50
        fctm=0.30*(fck)^(2/3);
    else fctm=2.12*log(1+(fcm/10));
 end

%6.2.2(4) 

alphaes(i)=Es/Ecm;
alphaep(i)=Ep/Ecm;
rhos(i)=Asl(i)/(bw*d);
rhop(i)=Ap/(bw*d);


alphaerhol(i)=alphaes(i)*rhos(i)+alphaep(i)*rhop(i);
x0(i)=d*0.75*(alphaerhol(i))^(1/3);            %feil??

sigmacp=max(NEd/Ac,0);

if     NEd==0
    x(i)=x0(i);
elseif NEd>0
    x(i)=min(x0(i)+0.80*(h-x0(i))*(d/h)*(sigmacp/(sigmacp+fctm)),h)
else   NEd<0
    x(i)=max(x0(i)*(1+0.1*(NEd*ds/MEd)),0)
end

%cottheta(i)=min(((0.85*d)/(d-x(i))),2.5);  
cottheta(i)=1;
theta_test(i)=acotd(min(((0.85*d)/(d-x(i))),2.5));
%Uten skjrarmering

a=MEd/VEd; %Kontroller mot a=0.25L
d0=max(d,100);
fcdcu=min(fcd,60);
zeta=max((2/sqrt(1+(d0/200)))*(d/a)^0.2,0.45);
%x(i)=1;
kc(i)=min(x(i)/d,0.20);  %kc=0.20 fra og med celle 105->Asl=205
bveff=bw;

% Strekkbrudd
Vcu_CM(i)=max(0.3*zeta*(x(i)/d)*((fcdcu)^(2/3))*bveff*d,0.25*(zeta*kc(i)+(20/d0))*(fcdcu)^(2/3)*bw*d);
   %Bytter fra Vmmin til Vmmax fra og med celle 243->Asl=343
Vmmax(i)=0.3*zeta*(x(i)/d)*((fcdcu)^(2/3))*bveff*d;
Vmmin(i)=0.25*(zeta*kc(i)+(20/d0))*(fcdcu)^(2/3)*bw*d;

    if Vmmax(i)>Vmmin(i);
        v(i)=1;
    else v(i)=2;
    end 

% Trykkbrudd
if sigmacp1==0;
    alphacw1(i)=1;
elseif 0 < sigmacp1 <= 0.25*fcd(i); 
    alphacw1(i)=1+sigmacp1/fcd(i);
elseif 0.25 < sigmacp1 < 0.5*fcd(i);
    alphacw1(i)=1.25;
else 0.5 < sigmacp1 < 1.0*fcd(i);
    alphacw1(i)=2.5*(1-sigmacp1/fcd(i));
end

if fck<=60
    nu(i)=0.60;
else
nu(i)=max(0.9-(fck/200),0.5);
end

VRdmaxCM(i)=alphacw1(i)*bw*z*nu(i)*fcd*((cottheta(i)+cotd(alpha))/(1+(cottheta(i))^2));

%Med skjrarmering

VRd_CM1(i)=Vcu_CM(i);

VRd_CM(i)=min(VRd_CM1(i),VRdmaxCM(i))*10^-3;
end

%% plot
figure(1),title 'Tverrsnitt med varierende lengdearmering uten beregningsmessig behov for skjrarmering',axis([axisxmin axisxmax axisymin axisymax])
hold on
plot(Asl,VRdc_ECus,'-g')    %EC
plot(Asl,VRdc_MCus,'-b')    %MC
plot(Asl,VRdNS_us,'-r')     %NS
plot(Asl,VRdc_MR_us,'-m')   %MR
plot(Asl,VRd_CM,'-black')   %CM
legend 'Kapasitet EC 2' 'Kapasitet MC 2010' 'Kapasitet NS 3473' 'Kapasitet MR' 'Kapasitet CM'
xlabel('100mm^2 < Asl < 3000mm^2')
ylabel('Skjrkapasitet, VRd [kN]')
hold off

figure(2),title 'Tverrsnitt med varierende lengdearmering uten beregningsmessig behov for skjrarmering',axis([axisxmin axisxmax axisymin axisymax])
hold on
plot(Asl,Vmmax*10^-3,'-g')    %EC
plot(Asl,Vmmin*10^-3,'-b')    %MC
legend 'Kapasitet Vmmax' 'Kapasitet Vmmin'
xlabel('100mm^2 < Asl < 3000mm^2')
ylabel('Skjrkapasitet, VRd [kN]')
hold off
